<script lang="ts">
  import { createEventDispatcher } from "svelte";
  import { getDefaultSettings, nRingsOptions } from "./settings";
  const dispatch = createEventDispatcher();

  export let settings: GameSettings = getDefaultSettings();

  let currentSettings = settings;

  let firstToNRings = settings.firstToNRings;

  $: if (settings !== currentSettings) {
    firstToNRings = settings.firstToNRings;
    currentSettings = settings;
  }

  export let readonly: boolean = false;

  function handleChange() {
    const newSettings = { firstToNRings };
    dispatch("settings_change", newSettings);
  }
</script>

<section>
  <fieldset>
    <legend>Player counts</legend>

    <ul class="horizontal">
      {#each [2] as c (c)}
        <li>
          <label class="player-count" for="player-count-{c}">
            <input
              id="player-count-{c}"
              type="checkbox"
              checked
              value={c}
              disabled
            />
            {c}
          </label>
        </li>
      {/each}
    </ul>
    <ul class="horizontal">
      <li><small>Recommended: 2</small></li>
      <li><small>Best: 2</small></li>
    </ul>
  </fieldset>

  <fieldset>
    <legend>Rings required to win</legend>
    <ul>
      {#each nRingsOptions as { n, description }}
        <li>
          <label class="n-rings" for="n-rings-{n}">
            <input
              type="radio"
              value={n}
              bind:group={firstToNRings}
              on:change={handleChange}
              disabled={readonly}
            />
            {n}
            <small>({description})</small>
          </label>
        </li>
      {/each}
    </ul>
  </fieldset>
</section>

<style>
  section {
    padding-bottom: 1rem;
    display: grid;
    row-gap: 1em;
  }

  fieldset {
    border: 0;
    padding: 0;
    margin: 0;
  }
  legend {
    padding: 0;
  }
  ul {
    margin: 0;
  }
  ul.horizontal {
    display: flex;
    flex-wrap: wrap;
    column-gap: 1em;
  }
  li {
    white-space: nowrap;
  }

  small {
    filter: opacity(90%);
  }
</style>
